interface initialCode {
  html?: string;
  css?: string;
  js: string;
}

interface event {
  content?: string;
}

interface HtmlJsCssBlockProps {
  onCodeChange?: (code: string) => void;
  isDarkModeEnabled?: boolean;
  isHorizontal?: boolean;
  editors?: string[];
  fontSize?: number;
  isAdjustable?: boolean;
  allowFullScreen?: boolean;
  isReadOnlyMode?: boolean;
  showDropdown?: boolean;
  initialCode?: initialCode;
  className?: string;
  editorsClassName?: string;
  editorClassName?: string;
  editorHeaderClassName?: string;
  previewClassName?: string;
  isExercise?: boolean;
  hints?: event[];
  solution?: object;
  domtestevents?: event[];
  showPreview?: boolean;
  hideEditorHeader?: boolean;
  primaryLang?: "html" | "css" | "js";
  isMultiPanel?: boolean;
  onCopyCode?: () => void;
  savedCode?: string;
  resourcePaths?: object;
}

interface ReactBlockProps {
  code: string;
  setCode: (code: string) => void;
  isEditable?: boolean;
  isDarkModeEnabled?: boolean;
  isHorizontal?: boolean;
}

export function HtmlJsCssBlock(props: HtmlJsCssBlockProps): JSX.Element;

export function ReactBlock(props: ReactBlockProps): JSX.Element;
